//This file separates the body parts scripts to keep stuff organized.

///////////////////////////////////////////////////////GLOBAL VARIABLES
$MAXTAILSWING = 55;

$ONCEARRANGENODESVER = false;
$ONCEARRANGENODESHOR = false;
$ONCEARRANGENODESDIG = false;

/*
	This is in the "onUpdate" function of the CatClass.
*/
function CatClass::moveParts(%this)
{
	%x = %this.getPositionX();
	%y = %this.getPositionY();
	
	//HEAD
	if(distanceBetweenPoints(%this,%this.getPositionX() SPC %this.getPositionY()-1.7 > 1,"BOTH"))
		%this.head.moveTo(%this.getPositionX(),%this.getPositionY()-1.7, %this.normalSpeed*2);
		
	//TAIL
	for(%i = 0; %i < $TAILSEGMENTCOUNT; %i++)
	{
		if(%this.getLinearVelocityX() < 0)
			%this.swingTail(%i,"LEFT");
			
		if(%this.getLinearVelocityX() > 0)
			%this.swingTail(%i,"RIGHT");
			
		if(%this.getLinearVelocityX() == 0)
			%this.swingTail(%i,"IDLE");
	}
	
	//PAWS
	%this.UpdatePaws();
	
	//LEGS
	%this.legPositioning();
	
	
	
	//We are no longer moving.
	if(%this.getLinearVelocityX() == 0 && %this.getLinearVelocityY() == 0)
	{
		%this.partsStopped();
	}
}

/*
	This makes a cat tail segment swing.
	PARAMS: %tailIndex = which tail segment to swing. %method = tells the function if we are going left, right or not moving horizontally.
*/
function CatClass::swingTail(%this,%tailIndex,%method)
{
	//This slows down the swinging so it doesn't get out of hand.
	if((%this.tail[0].getRotation() < %this.swingBase && %this.tail[0].tailArrest > %this.swingBase) || 
		(%this.tail[0].getRotation() > %this.swingBase && %this.tail[0].tailArrest < %this.swingBase))
	{
		for(%i = 0; %i < $TAILSEGMENTCOUNT; %i++)
		{
			if(%method !$= "RIGHT")
			{
			if(%this.tail[%i].swingFactor > %this.swingBase)
				%this.tail[%i].swingFactor = 7;
				
			if(%this.tail[%i].swingFactor < %this.swingBase)
				%this.tail[%i].swingFactor = -7;
			}
			
			if(%method $= "LEFT")
			{
			if(%this.tail[%i].swingFactor > %this.swingBase)
				%this.tail[%i].swingFactor = -7;
				
			if(%this.tail[%i].swingFactor < %this.swingBase)
				%this.tail[%i].swingFactor = 7;
			}
					
			%this.tail[%i].setRotation(%this.swingBase);	
		}
	}
	
	%this.tail[0].tailArrest = %this.tail[0].getRotation();
		
	if(%method $= "IDLE")
		%this.swingBase = 0;
	
	if(%method $= "LEFT")
		%this.swingBase = -30;
	
	if(%method $= "RIGHT")
		%this.swingBase = 30;
		
		
	//Move the tail segments.
	if(%tailIndex == 0)
		%this.tail[%tailIndex].setRotation(%this.tail[%tailIndex].getRotation()+%this.tail[%tailIndex].swingFactor);
	else
		%this.tail[%tailIndex].setRotation(%this.tail[%tailIndex-1].getRotation()+%this.tail[%tailIndex-1].swingFactor*-4);
	
	//Add swinging momentum.
	if(%this.tail[%tailIndex].getRotation() > %this.swingBase)
		%this.tail[%tailIndex].swingFactor -= %this.tail[%tailIndex].rotateAdd;
		
	if(%this.tail[%tailIndex].getRotation() < %this.swingBase)
		%this.tail[%tailIndex].swingFactor += %this.tail[%tailIndex].rotateAdd;
}


/*
	This sends the cat parts to their original places when stopping.
*/
function CatClass::partsStopped(%this)
{	
	%this.pawX = 0;
	%this.pawY = 0;
	%this.pawXY = 0;
	%this.pawOnceX = false;
	%this.pawOnceY = false;
	%this.pawOnceXY1 = false;
	%this.pawOnceXY2 = false;
	
	%this.paw[0].moveTo(%this.getPositionX()-2.7,%this.getPositionY()-1.7, %this.partSpeed);
	%this.paw[1].moveTo(%this.getPositionX()+2.7,%this.getPositionY()-1.7, %this.partSpeed);
	%this.paw[2].moveTo(%this.getPositionX()-2.7,%this.getPositionY()+2.7, %this.partSpeed);
	%this.paw[3].moveTo(%this.getPositionX()+2.7,%this.getPositionY()+2.7, %this.partSpeed);
}

/*
	This handles the legs positions at all times.
*/
function CatClass::legPositioning(%this)
{	
	%FLLX = %this.getPositionX()-((%this.getPositionX()-%this.paw[0].getPositionX())/2);
	%FLLY = %this.getPositionY()-((%this.getPositionY()-%this.paw[0].getPositionY())/2);
	
	%FLRX = %this.getPositionX()-((%this.getPositionX()-%this.paw[1].getPositionX())/2);
	%FLRY = %this.getPositionY()-((%this.getPositionY()-%this.paw[1].getPositionY())/2);
	
	%BLLX = %this.getPositionX()-((%this.getPositionX()-%this.paw[2].getPositionX())/2);
	%BLLY = %this.getPositionY()-((%this.getPositionY()-%this.paw[2].getPositionY())/2);
	
	%BLRX = %this.getPositionX()-((%this.getPositionX()-%this.paw[3].getPositionX())/2);
	%BLRY = %this.getPositionY()-((%this.getPositionY()-%this.paw[3].getPositionY())/2);	
	
	%this.frontLegLeft.setPosition(%FLLX-0.5,%FLLY);
	%this.frontLegRight.setPosition(%FLRX+0.5,%FLRY);
	%this.backLegLeft.setPosition(%BLLX-0.5,%BLLY+0.5);
	%this.backLegRight.setPosition(%BLRX+0.5,%BLRY+0.5);
	
	%catPosUpper = (%this.getPositionX())SPC(%this.getPositionY()-1);
	%catPosLower = (%this.getPositionX())SPC(%this.getPositionY()+1);
	
	%this.frontLegLeft.setRotation(90+angleFromPositions(%catPosUpper,%this.paw[0].getPosition()));
	%this.frontLegRight.setRotation(90+angleFromPositions(%catPosUpper,%this.paw[1].getPosition()));
	%this.backLegLeft.setRotation(90+angleFromPositions(%catPosLower,%this.paw[2].getPosition()));
	%this.backLegRight.setRotation(90+angleFromPositions(%catPosLower,%this.paw[3].getPosition()));
}

/*
	This makes a cat's head.
*/
function CatClass::makeHead(%this)
{
	%head = new t2dStaticSprite()
	{
		ImageMap = $HEADIM; 
		Config = "CatHead";
		Scenegraph = %this.getScenegraph();
		Position = %this.getPosition();
	};
	return %head;
}

/*
	This makes a cat's tail segment.
*/
function CatClass::makeTailSegment(%this)
{
	%tail = new t2dStaticSprite()
	{
		ImageMap = $TAILIM; 
		Config = "CatTail";
		Scenegraph = %this.getScenegraph();
		Position = %this.getPosition();
	};
	%tail.swingFactor = 7;
	%tail.rotateAdd = 0.5;
	%this.tail[0].tailArrest = 1000;
	return %tail;
}

/*
	This makes a cat's front leg.
*/
function CatClass::makeFrontLeg(%this)
{
	%frontLeg = new t2dStaticSprite()
	{
		ImageMap = $FRONTLEGIM; 
		Config = "CatFrontLeg";
		Scenegraph = %this.getScenegraph();
		Position = %this.getPosition();
	};
	return %frontLeg;
}

/*
	This makes a cat's back leg.
*/
function CatClass::makeBackLeg(%this)
{
	%backLeg = new t2dStaticSprite()
	{
		ImageMap = $BACKLEGIM; 
		Config = "CatBackLeg";
		Scenegraph = %this.getScenegraph();
		Position = %this.getPosition();
	};
	return %backLeg;
}

function CatClass::InitializePaws(%this)
{
	for(%i = 0; %i < 4; %i++)
	{
		%this.paw[%i] = new t2dStaticSprite()
		{
			ImageMap = %this.GetPawIM(%i); 
			Config = %this.GetConfig(%i);
			Scenegraph = %this.getScenegraph();
			Position = %this.getPosition();
		};
	}
	
	//Front paws.
	%this.paw[0].setPosition(%this.getPositionX()-%this.pawOffset,%this.getPositionY());
	%this.paw[1].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY());
	//Back paws.
	%this.paw[2].setPosition(%this.getPositionX()-%this.pawOffset,%this.getPositionY()+%this.outPawFactor);
	%this.paw[3].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY()+%this.outPawFactor);
}

function CatClass::UpdatePaws(%this)
{
	if(mAbs(%this.pawX) > %this.pawLimitFactor)
		%this.speedFactorX *= -1;
		
	if(mAbs(%this.pawY) > %this.pawLimitFactor)
		%this.speedFactorY *= -1;
		
	if(mAbs(%this.pawXY) > %this.pawLimitFactor)
		%this.speedFactorXY *= -1;
		
			
	//This cancels paws on route to default positions when moving.
	if(%this.getLinearVelocityX() != 0 || %this.getLinearVelocityY() != 0)
	{
		%this.paw[0].setPositionTargetOff();
		%this.paw[1].setPositionTargetOff();
		%this.paw[2].setPositionTargetOff();
		%this.paw[3].setPositionTargetOff();
		
		%this.paw[0].setLinearVelocity(0,0);
		%this.paw[1].setLinearVelocity(0,0);
		%this.paw[2].setLinearVelocity(0,0);
		%this.paw[3].setLinearVelocity(0,0);
	}
	
	//HORIZONTAL	
	if(%this.getLinearVelocityX() != 0 && %this.getLinearVelocityY() == 0)
	{	
		//This resets the paws positions once before moving them as to avoid the paws getting stuck in weird places.
		if(%this.pawOnceX == false)
		{
			//Front paws.
			%this.paw[0].setPosition(%this.getPositionX()-%this.pawOffset,%this.getPositionY());
			%this.paw[1].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY());
			//Back paws.
			%this.paw[2].setPosition(%this.getPositionX()-%this.pawOffset,%this.getPositionY()+%this.outPawFactor);
			%this.paw[3].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY()+%this.outPawFactor);
	
			%this.pawOnceX = true;
		}		
		
		//Front paws.
		%this.paw[0].setPositionX(%this.getPositionX()-%this.outPawFactor-%this.pawX);
		%this.paw[1].setPositionX(%this.getPositionX()+%this.outPawFactor-(%this.pawX*-1));
		//Back paws.
		%this.paw[2].setPositionX(%this.getPositionX()-%this.outPawFactor-(%this.pawX*-1));
		%this.paw[3].setPositionX(%this.getPositionX()+%this.outPawFactor-%this.pawX);		
		%this.pawX += %this.speedFactorX;
		
		//Reset other directions variables.
		%this.pawY = 0;
		%this.pawXY = 0;
		%this.pawOnceY = false;
		%this.pawOnceXY1 = false;
		%this.pawOnceXY2 = false;
	}
	
	//VERTICAL	
	if(%this.getLinearVelocityY() != 0 && %this.getLinearVelocityX() == 0)
	{
		if(%this.pawOnceY == false)
		{
			//Front paws.
			%this.paw[0].setPosition(%this.getPositionX()-%this.pawOffset,%this.getPositionY());
			%this.paw[1].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY());
			//Back paws.
			%this.paw[2].setPosition(%this.getPositionX()-%this.pawOffset,%this.getPositionY()+%this.outPawFactor);
			%this.paw[3].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY()+%this.outPawFactor);
	
			%this.pawOnceY = true;
		}
		
		//Front paws.
		%this.paw[0].setPositionY(%this.getPositionY()-%this.outPawFactor-%this.pawY);
		%this.paw[1].setPositionY(%this.getPositionY()-%this.outPawFactor-(%this.pawY*-1));
		%this.paw[2].setPositionY(%this.getPositionY()+%this.outPawFactor-%this.pawY);
		%this.paw[3].setPositionY(%this.getPositionY()+%this.outPawFactor-(%this.pawY*-1));
		%this.pawY += %this.speedFactorY;
		
		//Reset other directions variables.
		%this.pawX = 0;
		%this.pawXY = 0;
		%this.pawOnceX = false;
		%this.pawOnceXY1 = false;
		%this.pawOnceXY2 = false;
	}
	
	//UPPER LEFT TO LOWER RIGHT
	if((%this.getLinearVelocityX() < 0 && %this.getLinearVelocityY() < 0)||(%this.getLinearVelocityX() > 0 && %this.getLinearVelocityY() > 0))
	{
		if(%this.pawOnceXY1 == false)
		{
			//Front paws.
			%this.paw[0].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY());
			%this.paw[1].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY());
			//Back paws.
			%this.paw[2].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY()+%this.outPawFactor);
			%this.paw[3].setPosition(%this.getPositionX()-%this.pawOffset,%this.getPositionY()+%this.outPawFactor);
			
			%this.pawOnceXY1 = true;
		}
		
		//Front paws.
		%this.paw[0].setPosition(%this.getPositionX()-%this.outPawFactor-%this.pawXY,%this.getPositionY()-%this.outPawFactor-%this.pawXY);
		%this.paw[1].setPosition(%this.getPositionX()+%this.outPawFactor-(%this.pawXY*-1),%this.getPositionY()-%this.outPawFactor-(%this.pawXY*-1));
		//Back paws.
		%this.paw[3].setPosition(%this.getPositionX()+%this.outPawFactor+(%this.pawXY*-1),%this.getPositionY()+%this.outPawFactor+(%this.pawXY*-1));
		%this.paw[2].setPosition(%this.getPositionX()-%this.outPawFactor+%this.pawXY,%this.getPositionY()+%this.outPawFactor+%this.pawXY);
		%this.pawXY += %this.speedFactorXY;
		
		//Reset other directions variables.
		%this.pawX = 0;
		%this.pawY = 0;
		%this.pawOnceX = false;
		%this.pawOnceY = false;
		%this.pawOnceXY2 = false;
	}
	
	
	//UPPER RIGHT TO LOWER LEFT
	if((%this.getLinearVelocityX() > 0 && %this.getLinearVelocityY() < 0)||(%this.getLinearVelocityX() < 0 && %this.getLinearVelocityY() > 0))
	{
		if(%this.pawOnceXY2 == false)
		{
			//Front paws.
			%this.paw[0].setPosition(%this.getPositionX()-%this.pawOffset,%this.getPositionY());
			%this.paw[1].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY());
			//Back paws.
			%this.paw[2].setPosition(%this.getPositionX()+%this.pawOffset,%this.getPositionY()+%this.outPawFactor);
			%this.paw[3].setPosition(%this.getPositionX()-%this.pawOffset,%this.getPositionY()+%this.outPawFactor);
	
			%this.pawOnceXY2 = true;
		}
		
		//Front paws.
		%this.paw[0].setPosition(%this.getPositionX()-%this.outPawFactor-%this.pawXY,%this.getPositionY()-%this.outPawFactor+%this.pawXY);
		%this.paw[1].setPosition(%this.getPositionX()+%this.outPawFactor-(%this.pawXY*-1),%this.getPositionY()-%this.outPawFactor+(%this.pawXY*-1));
		//Back paws.
		%this.paw[3].setPosition(%this.getPositionX()+%this.outPawFactor+(%this.pawXY*-1),%this.getPositionY()+%this.outPawFactor-(%this.pawXY*-1));
		%this.paw[2].setPosition(%this.getPositionX()-%this.outPawFactor+%this.pawXY,%this.getPositionY()+%this.outPawFactor-%this.pawXY);
		%this.pawXY += %this.speedFactorXY;
		
		//Reset other directions variables.
		%this.pawX = 0;
		%this.pawY = 0;
		%this.pawOnceX = false;
		%this.pawOnceY = false;
		%this.pawOnceXY1 = false;
	}	
}

function CatClass::GetPawIM(%this,%num)
{
	switch(%num)
	{
		case 0: return $FRONTPAWIM;
		case 1: return $FRONTPAWIM;
		case 2: return $BACKPAWIM;
		case 3: return $BACKPAWIM;
		default: echo("Bad Paw IM");
					return "NULL";	
	}
}

function CatClass::GetConfig(%this,%num)
{
	switch(%num)
	{
		case 0: return "CatFrontPaw";
		case 1: return "CatFrontPaw";
		case 2: return "CatBackPaw";
		case 3: return "CatBackPaw";
		default: echo("Bad paw Datablock");
					return "NULL";	
	}
}

/*
	This handles the creating of the baddie attack effect and such.
	PARAMS: %baddie = enemy to attack
*/
function CatClass::slashBaddie(%this,%baddie)
{
	//Baddie is to the right.
	if(%baddie.getPositionX() > %this.getPositionX())
	{
		//Baddie is to the upper right.
		if(%baddie.getPositionY() < %this.getPositionY())
		{
			%pawOrigin = 1;
		}else //Baddie is to the lower right.
		{
			%pawOrigin = 3;
		}
		
	}else //Baddie is to the left.
	{
		//Baddie is to the upper left.
		if(%baddie.getPositionY() < %this.getPositionY())
		{
			%pawOrigin = 0;
		}else //Baddie is to the lower left.
		{
			%pawOrigin = 2;
		}
		
	}
	
	%newLeg = new t2dStaticSprite()
	{
		ImageMap = "BrownTanCatFrontLegIMImageMap"; 
		Config = "CatFrontLeg";
		Scenegraph = %this.getScenegraph();
		Position = %this.paw[%pawOrigin].getPosition();
	};
	
	switch$(%pawOrigin)
	{
		case 0: %whichLeg = %this.frontLegLeft;
		case 1: %whichLeg = %this.frontLegRight;
		case 2: %whichLeg = %this.backLegLeft;
		case 3: %whichLeg = %this.backLegRight;
	}
	
	%slasher = new t2dStaticSprite()
	{
		ImageMap = "BrownTanCatFrontPawIMImageMap"; 
		Config = "CatFrontPaw";
		Class = "SlashPawClass";
		Scenegraph = %this.getScenegraph();
		Position = %this.paw[%pawOrigin].getPosition();
		targetPaw = %this.paw[%pawOrigin];
		targetLeg = %whichLeg;
		newLeg = %newLeg;
	};
	
	%slashEffect = new t2dParticleEffect()
	{
		SceneGraph = %this.getScenegraph();
		Config = "CatFrontPaw";
		Layer = 16;
	};
	
	%slashEffect.loadEffect("~/data/particles/CatSlashingEffect.eff");
	%slashEffect.playEffect();
	
	%slashEffect.mount(%slasher);
	
	%whichLeg.setVisible(false);
	%this.paw[%pawOrigin].setVisible(false);
	%slasher.moveTo(%baddie.getPosition(),%this.slashSpeed,true,true,true,0.1);
}