///////////////////////////////////////////////////////GLOBAL VARIABLES

$startButtonLive = false;

//These hold the current body image maps.
/*$BODYIM     = "BrownTanCatBodyIMImageMap";
$HEADIM     = "BrownTanCatHeadIMImageMap";
$TAILIM     = "BrownTanCatTailIMImageMap";
$FRONTLEGIM = "BrownTanCatFrontLegIMImageMap";
$FRONTPAWIM = "BrownTanCatFrontPawIMImageMap";
$BACKLEGIM  = "BrownTanCatBackLegIMImageMap";
$BACKPAWIM  = "BrownTanCatBackPawIMImageMap";*/
$PATHNODECOUNT 	= 3;
$TAILSEGMENTCOUNT = 3;
$TAILSEGMENTDRAG  = 20;

/*
$BODYIM     = "BlackCatBodyIMImageMap";
$HEADIM     = "BlackCatHeadIMImageMap";
$TAILIM     = "BlackCatTailIMImageMap";
$FRONTLEGIM = "BlackCatFrontLegIMImageMap";
$FRONTPAWIM = "BlackCatFrontPawIMImageMap";
$BACKLEGIM  = "BlackCatBackLegIMImageMap";
$BACKPAWIM  = "BlackCatBackPawIMImageMap";
*/

///////////////////////////////////////////////////////PRE-DEFINED

//IF SOUND NO WORK CHECK audio.cs FILE 'if($pref::Audio::driver !$= "OpenAL")'


function CatClass::onAdd(%this)
{		
	//$timeScale = 0.5;
	%this.setCollisionLayers("0 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31");

	//Initialize
	sceneWindow2D.mount(%this,"0 0",20,false);
	if($startButtonLive)
		sceneWindow2D.makeStartDisplay();
	moveMap.bindCmd(keyboard,"enter", "startTheLevel();", "");
	
	%this.enableUpdateCallback();
	%this.setLinearVelocity(0,0);
	%this.wallCollider = %this.makeCollisionMask();
	%this.scoreDirigible = %this.makeDirigible();
	%this.head 			  = %this.makeHead();
	%this.frontLegLeft  = %this.makeFrontLeg();
	%this.frontLegRight = %this.makeFrontLeg();
	%this.backLegLeft   = %this.makeBackLeg();
	%this.backLegRight  = %this.makeBackLeg();
	
	for(%i = 0; %i < $TAILSEGMENTCOUNT; %i++)
	{
		%this.tail[%i] = %this.makeTailSegment();
		
		if(%i == 0)
			%this.tail[%i].mount(%this,0,0.85,0,false,false,false,false);
		else
		{
			%this.tail[%i].mount(%this.tail[%i-1],0,1,0,false,false,false,false);
		}
	}
	
	//Input
	%this.setUseMouseEvents(true);
	//Arrow keys.
	moveMap.bindCmd(keyboard,"up", "moveUp();", "stopUp();");
	moveMap.bindCmd(keyboard,"down", "moveDown();", "stopDown();");
	moveMap.bindCmd(keyboard,"left", "moveLeft();", "stopLeft();");
	moveMap.bindCmd(keyboard,"right", "moveRight();", "stopRight();");
	//WASD keys.
	moveMap.bindCmd(keyboard,"w", "moveUp();", "stopUp();");
	moveMap.bindCmd(keyboard,"s", "moveDown();", "stopDown();");
	moveMap.bindCmd(keyboard,"a", "moveLeft();", "stopLeft();");
	moveMap.bindCmd(keyboard,"d", "moveRight();", "stopRight();");
	
	//Variables
	%this.up = %this.down = %this.left = %this.right = false;
	%this.moveSpeed = 20;
	%this.normalSpeed = %this.moveSpeed;
	%this.diagonalSpeed = %this.moveSpeed-3;//mSqrt(%this.moveSpeed*4); //This makes diagonal moving just as fast as normal moving.
	%this.pawSpeed = %this.moveSpeed+2;
	%this.fixSpeed = true;
	%this.keyOrbiting = 0;
	
	
	%this.mouseMove = false;
	%this.numKeys = 0;
	%this.mouseTarget = "EMPTY";
	%this.partSpeed = 12;
	%this.swingBase = 0;
	%this.clawNum = 0;
	
	%this.outPawFactor = 2.5;
	%this.pawLimitFactor = 1;
	
	%this.InitializePaws();
	
	%this.pawOffset = 2.5;
	%this.pawX = %this.pawY = %this.pawXY = 0;
	%this.speedFactorX = %this.speedFactorY = %this.speedFactorXY = %this.moveSpeed*-0.03;
	%this.pawOnceX = %this.pawOnceY = %this.pawOnceXY1 = %this.pawOnceXY2 = false;
	
	%this.pawSlashRadius = 4;
	%this.slashSpeed = 50;
	
	%this.newLine = "";
}

function CatClass::onUpdate(%this)
{	
	%this.checkImages();	
	
	if($startButtonLive)
	{
		%size = sceneWindow2D.getWorldPoint(getWord(sceneWindow2D.getWindowExtents(),2)/2,getWord(sceneWindow2D.getWindowExtents(),3)/2);
		sceneWindow2D.startButton.setPosition(getWord(%size,0),getWord(%size,1));
		sceneWindow2D.pressEnter.setPosition(getWord(%size,0)+44,getWord(%size,1)-20);
	}
	
	if(%this.getLinearVelocityX() != 0 && %this.getLinearVelocityY() != 0)
	{	
		if(%this.fixSpeed == true)
		{
			%this.moveSpeed = %this.diagonalSpeed;		
			
			if(%this.getLinearVelocityX() > 0)
			{
				stopRight();
				moveRight();
			}else
			{
				stopLeft();
				moveLeft();
			}
				
			if(%this.getLinearVelocityY() > 0)
			{
				stopDown();
				moveDown();
			}else
			{
				stopUp();
				moveUp();
			}
			
			%this.fixSpeed = false;	
		}
	}else
	{
		%this.fixSpeed = true;
		%this.moveSpeed = %this.normalSpeed;
		
		if(%this.getLinearVelocityX() > 0)
		{
			stopRight();
			moveRight();
		}else if(%this.getLinearVelocityX() < 0)
		{
			stopLeft();
			moveLeft();
		}
				
		if(%this.getLinearVelocityY() > 0)
		{
			stopDown();
			moveDown();
		}else if(%this.getLinearVelocityY() < 0)
		{
			stopUp();
			moveUp();
		}
	}
	
	%this.moveParts();
	
	//If okay to do so set target destination and move towards it.
	if(%this.mouseMove && !$startButtonLive && $CATEDITOR == 1)
	{
		%this.mouseTarget.setPosition(sceneWindow2D.getMousePosition());
		%this.moveToTarget();
	}
	
	for(%jelly = 0; %jelly < $MEGAJELLYCOUNT; %jelly++)
	{
		%dist = distanceBetweenPoints(%this,$MEGAJELLIES[%jelly],"BOTH");
		
		if(%dist < 70)
		{
			if(%dist < 50)
				%dist = 50;
				
			sceneWindow2D.setCurrentCameraZoom(%dist/70);
		}else
			sceneWindow2D.setCurrentCameraZoom(1);
	}
	
	//If near the target, stop.
	if(%this.mouseTarget !$= "EMPTY" && ( (%this.getLinearVelocityX() == 0 && %this.getLinearVelocityY() == 0) || distanceBetweenPoints(%this,%this.mouseTarget,"Both") < 2 ) )
	{
		stopDown();
		stopUp();
		stopLeft();
		stopRight();
		%this.mouseTarget.setPosition("-10000 -10000");
		//%this.setPosition(%this.mouseTarget.getPosition());	
	}
	
	%this.checkMaskWallCollision();
	
	//%this.setLinearVelocity(VectorNormalize(%this.getLinearVelocityX() SPC %this.getLinearVelocityY()));
}

function CatClass::onPositionTarget(%this)
{
	if(!MainCat.mouseMove)
	{
		%this.setLinearVelocity(0,0);
	}
}

function CatClass::onCollision(%srcObject, %dstObject, %srcRef, %dstRef, %time, %normal, %contacts, %points)
{
	///////////////////////////////////////////////////////////Body Parts
	if(%dstObject.class $= "CollectablePartClass")
	{
		%dstObject.safeDelete();
	}
	///////////////////////////////////////////////////////////Body Parts
	if(%dstObject.class $= "BodyPartsClassNOTRIGHTNOW")
	{
		if(%dstObject.noHorizontal == true)
		{
			%srcObject.setLinearVelocityX(0);	
		}
		
		if(%dstObject.noVertical == true)
		{
			%srcObject.setLinearVelocityY(0);	
		}
	}
	///////////////////////////////////////////////////////////Door
	if(%dstObject.class $= "DoorClass")
	{
		if(%srcObject.keyOrbiting > 0)
		{
			%srcObject.keyBalance(-1);
			%dstObject.openDoor();
			%dstObject.safeDelete();
		}
	}
	///////////////////////////////////////////////////////////Goodie
	if(%dstObject.class $= "GoodieClass")
	{
		%dstObject.safeDelete();
		
		%srcObject.newLine = "";
		for(%i = 0; %i < %dstObject.goodieNum; %i++)
			%srcObject.newLine = %srcObject.newLine@getWord($LEVELLINE,%i)@" ";
		%srcObject.newLine = %srcObject.newLine@"1 ";
		
		%srcObject.newLine = %srcObject.newLine@getSubStr($LEVELLINE,strlen(%srcObject.newLine),99999);
		
		$LEVELSAVE[$currentLevel] = %srcObject.newLine;
		$LEVELLINE = %srcObject.newLine;
		
		$SCORE += 1;	
	}
	///////////////////////////////////////////////////////////Key
	if(%dstObject.class $= "KeyClass")
	{
		%srcObject.numKeys++;
		%dstObject.safeDelete();
		%srcObject.makeMiniKey();
	}
	///////////////////////////////////////////////////////////Swipe
	if(%dstObject.class $= "ClawClass")
	{
		%srcObject.clawNum++;
		%dstObject.safeDelete();
		%srcObject.addAttackClaw();
	}
	///////////////////////////////////////////////////////////Baddie
	if(%dstObject.SuperClass $= "BaddieClass")
	{
		if(%srcObject.clawNum > 0 && !%dstObject.unkillable){
			%srcObject.swipeBalance(-1);
			%srcObject.clawNum--;
			%srcObject.slashBaddie(%dstObject);
			%dstObject.safeDelete();	
		}else
		{
			sceneWindow2D.makeStartDisplay(%this);
			%srcObject.safeDelete();
			$startButtonLive = true;
		} 
	}
	///////////////////////////////////////////////////////////Finish
	//if(%dstObject.class $= "FinishClass")
		//sceneWindow2D.schedule(0,"nextLevelPlease");
}

function CatClass::onRemove(%this)
{
	if(isObject(%this.frontLegLeft))
	{
		makeDeadBodyPart(%this.frontLegLeft);
		%this.frontLegLeft.safeDelete();
	}
	if(isObject(%this.frontLegRight))
	{
		makeDeadBodyPart(%this.frontLegRight);
		%this.frontLegRight.safeDelete();
	}
	if(isObject(%this.backLegLeft))
	{
		makeDeadBodyPart(%this.backLegLeft);
		%this.backLegLeft.safeDelete();
	}
	if(isObject(%this.backLegRight))
	{
		makeDeadBodyPart(%this.backLegRight);
		%this.backLegRight.safeDelete();
	}

	
	if(isObject(%this.paw[0]))
	{
		makeDeadBodyPart(%this.paw[0]);
		%this.paw[0].safeDelete();
	}
	if(isObject(%this.paw[1]))
	{
		makeDeadBodyPart(%this.paw[1]);
		%this.paw[1].safeDelete();
	}
	if(isObject(%this.paw[2]))
	{
		makeDeadBodyPart(%this.paw[2]);
		%this.paw[2].safeDelete();
	}
	if(isObject(%this.paw[3]))
	{
		makeDeadBodyPart(%this.paw[3]);
		%this.paw[3].safeDelete();
	}
	
	if(isObject(%this.head))
		makeDeadBodyPart(%this.head);
	if(isObject(%this.head))
		%this.head.safeDelete();
	
	for(%i = 0; %i < $TAILSEGMENTCOUNT; %i++)
	{
		if(isObject(%this.tail[%i]))
		{
			makeDeadBodyPart(%this.tail[%i]);
			%this.tail[%i].safeDelete();
		}
	}
	
	if(isObject(%this.scoreDirigible))
	{
		%deadDirigible = makeDeadBodyPart(%this.scoreDirigible);
		%deadDirigible.setCollisionActive(false,false);
		%deadDirigible.setConstantForce(0,100,true);
		%this.scoreDirigible.safeDelete();
	}
	
	if(isObject(%this.wallCollider))
		%this.wallCollider.safeDelete();
	
	makeDeadBodyPart(%this);
}

////////////////////////////////////////////////////////MOVEMENT

/*
	Makes the MainCat move up.
*/
function moveUp(%this)
{
	if($startButtonLive || $CATEDITOR == -1) return;
	
	if(MainCat.up == false)
	{//This happens when the up button is pressed.
		MainCat.up = true;
		MainCat.setLinearVelocityY(-MainCat.moveSpeed);
	}
}

/*
	Makes MainCat stop going up.
*/
function stopUp(%this)
{
	if($startButtonLive || $CATEDITOR == -1) return;
	
	if(MainCat.up == true)
	{//This stuff happens when the player stops pressing the up button.
		MainCat.up = false;	
		
		if(MainCat.down == false)
		{//This happens when both vertical keys are not pressed.
			if(MainCat.left == true || MainCat.right == true)
			{//This happens when one of the horizontal keys are pressed.
				if(MainCat.down != true)
					MainCat.setLinearVelocityY(0);
				else
					MainCat.setLinearVelocityY(-MainCat.moveSpeed);
			}else
				MainCat.setLinearVelocity(0,0);
		}else
		{//This mimics the opposite key's movement effect.
			MainCat.setLinearVelocityY(MainCat.moveSpeed);
		}
	}
}

/*
	Makes MainCat move up.
*/
function moveDown(%this)
{
	if($startButtonLive || $CATEDITOR == -1) return;
		
	if(MainCat.down == false)
	{//This happens when the down button is pressed.
		MainCat.down = true;
		MainCat.setLinearVelocityY(MainCat.moveSpeed);
	}
}

/*
	Makes MainCat stop going down.
*/
function stopDown(%this)
{
	if($startButtonLive || $CATEDITOR == -1) return;
		
	if(MainCat.down == true)
	{//This stuff happens when the player stops pressing the down button.
		MainCat.down = false;
		
		if(MainCat.up == false)
		{//This happens when both vertical keys are not pressed.
		
		if(MainCat.left == true || MainCat.right == true)
		{//This happens when one of the horizontal keys are pressed.
			if(MainCat.up != true)
				MainCat.setLinearVelocityY(0);
			else
				MainCat.setLinearVelocityY(MainCat.moveSpeed);
		}else
		{
			MainCat.setLinearVelocity(0,0);
		}
		}else
		{//This mimics the opposite key's movement effect.
			MainCat.setLinearVelocityY(-MainCat.moveSpeed);
		}	
	}
}

/*
	Makes MainCat move left.
*/
function moveLeft(%this)
{
	if($startButtonLive || $CATEDITOR == -1) return;
		
	if(MainCat.left ==false)
	{//This happens when the left button is pressed.
		MainCat.left = true;
		MainCat.setLinearVelocityX(-MainCat.moveSpeed);
	}
}

/*
	Makes MainCat stop going left.
*/
function stopLeft(%this)
{
	if($startButtonLive || $CATEDITOR == -1) return;
		
	if(MainCat.left == true)
	{//This stuff happens when the player stops pressing the left button.
		MainCat.left = false;
		
		if(MainCat.right == false)
		{//This happens when both horizontal keys are not pressed.
		
		if(MainCat.up == true || MainCat.down == true)
		{//This happens when one of the vertical keys are pressed.
			if(MainCat.right != true)
				MainCat.setLinearVelocityX(0);
			else
				MainCat.setLinearVelocityX(MainCat.moveSpeed);
		}else
		{
			MainCat.setLinearVelocity(0,0);
		}
		}else
		{//This mimics the opposite key's movement effect.
			MainCat.setLinearVelocityX(MainCat.moveSpeed);
		}
	}
}

/*
	Makes MainCat move right.
*/
function moveRight(%this)
{
	if($startButtonLive || $CATEDITOR == -1) return;
		
	if(MainCat.right == false)
	{//This happens when the right button is pressed
		MainCat.right = true;
		MainCat.setLinearVelocityX(MainCat.moveSpeed);
	}
}

/*
	Makes cat stop going right.
*/
function stopRight(%this)
{
	if($startButtonLive || $CATEDITOR == -1) return;
		
	if(MainCat.right == true)
	{//This stuff happens when the player stops pressing the right button.
		MainCat.right = false;	
		
		if(MainCat.left == false)
		{//This happens when both horizontal keys are not pressed.
		
		if(MainCat.up == true || MainCat.down == true)
		{//This happens when one of the vertical keys are pressed.
			if(MainCat.left != true)
				MainCat.setLinearVelocityX(0);
			else
				MainCat.setLinearVelocityX(-MainCat.moveSpeed);
		}else
		{
			MainCat.setLinearVelocity(0,0);
		}
		}else
		{//This mimics the opposite key's movement effect.
			MainCat.setLinearVelocityX(-MainCat.moveSpeed);
		}
	}
}

//////////////////////////////////////////////////////////SUPPORT

/*
	This realigns the attack ready effects to be properly spread around the cat.
*/
function CatClass::swipeBalance(%this,%factor){
	if(%factor == 1){
		%this.attackEffectIds[%this.clawNum] = %this.clawReady;
		switch(%this.clawNum)
		{
			case 1: 	%this.attackEffectIds[%this.clawNum].target = %this.paw[%this.clawNum-1];
						
			case 2: 	%this.attackEffectIds[%this.clawNum].target = %this.paw[%this.clawNum-1];
						
			case 3: 	%this.attackEffectIds[%this.clawNum].target = %this.paw[%this.clawNum-1];
						
			case 4: 	%this.attackEffectIds[%this.clawNum].target = %this.paw[%this.clawNum-1];
		}
		
		if(%this.clawNum > 4)
			%this.attackEffectIds[%this.clawNum].safeDelete();
	}
	else if(%factor == -1 && %this.clawNum < 5)
		%this.attackEffectIds[%this.clawNum].safeDelete();
}

/*
	This makes a new attack ready effect.
*/
function CatClass::addAttackClaw(%this)
{
	if(%this.clawsNum < 5)
	{
		%this.clawReady = new t2dParticleEffect()
		{
			Class = "AttackEffectClass";
			SceneGraph = %this.getScenegraph();
			Layer = 16;
		};
		%this.swipeBalance(1);
	}
}

/*
	This makes a new dirigible for keeping score.
*/
function CatClass::makeDirigible(%this)
{
	%dirigible = new t2dAnimatedSprite()
	{
		AnimationName = "DirigibleRightANIM";
		Config = "Dirigible";
		Scenegraph = %this.getScenegraph();
		Position = %this.getPositionX()SPC%this.getPositionY()-15;
	};
	return %dirigible;
}

/*
	This realigns the orbiting keys to be equally spread around the MainCat.
	PARAMETERSS: %factor = Is either 1 or -1 depending on if we are gaining or losing a key.
*/
function CatClass::keyBalance(%this,%factor)
{
	//%factor is either 1 or -1 depending on if we are gaining or losing a key.
	%this.keyOrbiting += %factor;
	if(%factor == 1) 
		%this.keyIds[%this.keyOrbiting] = %this.miniKey;
	else
		%this.keyIds[%this.keyOrbiting+1].safeDelete();
	
	%rotateOffset = 0;	
	
	for(%i = 1; (%i < %this.keyOrbiting+1 && %this.keyOrbiting != 1); %i++)
	{
		%rotateOffset += 360/%this.keyOrbiting;
		%this.keyIds[%i].pos = %rotateOffset;
	}
}

/*
	Makes a new orbiting mini key object.
*/
function CatClass::makeMiniKey(%this)
{
	%this.miniKey = new t2dStaticSprite()
	{
		Scenegraph = %this.getScenegraph();
		Class = "OrbitingKeyClass";
		ImageMap = "KeyIMImageMap";
		Size = "2 2";
	};
	%this.keyBalance(1);
}

/*
	This casts collisions with a mask and checks for collisions and moves
	the MainCat depending on the results.
*/
function CatClass::checkMaskWallCollision(%this)
{
	%this.wallCollider.setPosition(%this.getPosition());
	
	//These next four segments facilitate the fact when hitting a wall, movement in a horizontal or vertical plane
	//is halted but perhaps the other plane allows movement. The player will move along the wall until a break in the 
	//wall that originally stopped movement in the certain plain is found in which the original movement will resume.
	//Also, by using an invisible object for checking collisions it eliminates some jumpy behavior in the original object.
	%this.checkGoingUp();
	%this.checkGoingDown();
	%this.checkGoingLeft();
	%this.checkGoingRight();
}

/*
	This encapsulates the up checking.
*/
function CatClass::checkGoingUp(%this)
{
	if(%this.up && %this.getLinearVelocityY() == 0 && !%this.down)
	{
		%this.wallCollider.setPositionY(%this.getPositionY()-0.001);
		%this.wallCollider.setLinearVelocityY(-10);
		%futureHit = %this.wallCollider.castCollisionList(0.001);
		%this.wallCollider.setLinearVelocityY(0);

		if(%futureHit $= "")//getWord(%futureHit,1) $= "")
		{
			%this.up = false;
			moveUp();
		}
		
		%this.wallCollider.setPositionY(%this.getPositionY()+0.001);
	}
}

/*
	This encapsulates the down checking.
*/
function CatClass::checkGoingDown(%this)
{
	if(%this.down && %this.getLinearVelocityY() == 0 && !%this.up)
	{
		%this.wallCollider.setPositionY(%this.getPositionY()+0.001);
		%this.wallCollider.setLinearVelocityY(10);
		%futureHit = %this.wallCollider.castCollisionList(0.001);
		%this.wallCollider.setLinearVelocityY(0);
		
		if(%futureHit $= "")
		{
			%this.down = false;
			moveDown();
		}
		
		%this.wallCollider.setPositionY(%this.getPositionY()-0.001);
	}
}

/*
	This encapsulates the left checking.
*/
function CatClass::checkGoingLeft(%this)
{
	if(%this.left && %this.getLinearVelocityX() == 0 && !%this.right)
	{
		%this.wallCollider.setPositionX(%this.getPositionX()-0.001);
		%this.wallCollider.setLinearVelocityX(-10);
		%futureHit = %this.wallCollider.castCollisionList(0.001);
		%this.wallCollider.setLinearVelocityX(0);
		
		if(%futureHit $= "")
		{
			%this.left = false;
			moveLeft();
		}
		
		%this.wallCollider.setPositionX(%this.getPositionX()+0.001);
	}
}

/*
	This encapsulates the Right checking.
*/
function CatClass::checkGoingRight(%this)
{
	if(%this.right && %this.getLinearVelocityX() == 0 && !%this.left)
	{
		%this.wallCollider.setPositionX(%this.getPositionX()+0.001);
		%this.wallCollider.setLinearVelocityX(5);
		%futureHit = %this.wallCollider.castCollisionList(0.001);
		%this.wallCollider.setLinearVelocityX(0);
		
		if(%futureHit $= "")//getWord(%futureHit,1).superClass !$= "BlockageClass" || %futureHit $= "")//getWord(%futureHit,1) $= "")
		{
			%this.right = false;
			moveRight();
		}
		
		%this.wallCollider.setPositionX(%this.getPositionX()-0.001);
	}
}

/*
	Makes a mask object that will checks for collisions ahead of the main
	cat object to fix glitchy movement along walls.
*/
function CatClass::makeCollisionMask(%this)
{	
	%wallCollider = new t2dStaticSprite()
	{
		Scenegraph = %this.scenegraph;
		Visible = false;
		Position = %this.getPosition();
		imageMap = $BODYIM;
		CollisionPolyList = "-0.750 -0.750 0.750 -0.750 0.750 1.000 -0.750 1.000";
	};
	//%wallCollider.setSize("8 8");
	
	%wallCollider.setCollisionLayers("24");
	%wallCollider.setCollisionActive(true,false);
	%wallCollider.setCollisionDetection(FULL);
	%wallCollider.setCollisionPhysics(false,false);
	return %wallCollider;
}

function CatClass::moveToTarget(%this)
{	
	if(%this.mouseMove)
		%angle = angleFromPositions(%this,%this.mouseTarget);
	
	//Moving Right
	if((%angle < 22.5 && %angle > -1)|| %angle > 337.5)
	{moveRight();
		stopLeft();stopUp();stopDown();}
	
	//Moving Left
	if(%angle < 202.5 && %angle >= 157.5)
	{moveLeft();
		stopRight();stopDown();stopUp();}
	
	//Moving Up
	if(%angle < 292.5 && %angle >= 247.5)
	{moveUp(); 
		stopDown();stopLeft();stopRight();}
	
	//Moving Down
	if(%angle < 112.5 && %angle >= 67.5)
	{moveDown();
		stopUp();stopRight();stopLeft();}
	
	//Moving Right Up
	if(%angle < 337.5 && %angle >= 292.5)
	{moveRight();moveUp();
		stopLeft();stopDown();}
	
	//Moving Right Down
	if(%angle < 67.5 && %angle >= 22.5)
	{moveRight();moveDown();
		stopLeft();stopUp();}
	
	//Moving Left Up
	if(%angle < 247.5 && %angle >= 202.5)
	{moveLeft();moveUp();
		stopRight();stopDown();}
	
	//Moving Left Down
	if(%angle < 157.5 && %angle >= 112.5)
	{moveLeft();moveDown();
		stopRight();stopUp();}
}

function CatClass::checkImages(%this)
{
	if(%this.head.getImageMap() !$= $HEADIM)
		%this.head.setImageMap($HEADIM);
	
	if(%this.getImageMap() !$= $BODYIM)
		%this.setImageMap($BODYIM);	
	
	if(%this.paw[0].getImageMap() !$= $FRONTPAWIM)
		%this.paw[0].setImageMap($FRONTPAWIM);
		
	if(%this.paw[1].getImageMap() !$= $FRONTPAWIM)
		%this.paw[1].setImageMap($FRONTPAWIM);
		
	if(%this.paw[2].getImageMap() !$= $BACKPAWIM)
		%this.paw[2].setImageMap($BACKPAWIM);
		
	if(%this.paw[3].getImageMap() !$= $BACKPAWIM)
		%this.paw[3].setImageMap($BACKPAWIM);
	
	if(%this.FrontLegLeft.getImageMap() !$= $FRONTLEGIM)
		%this.FrontLegLeft.setImageMap($FRONTLEGIM);
		
	if(%this.FrontLegRight.getImageMap() !$= $FRONTLEGIM)
		%this.FrontLegRight.setImageMap($FRONTLEGIM);
		
	if(%this.BackLegLeft.getImageMap() !$= $BACKLEGIM)
		%this.BackLegLeft.setImageMap($BACKLEGIM);
		
	if(%this.BackLegRight.getImageMap() !$= $BACKLEGIM)
		%this.BackLegRight.setImageMap($BACKLEGIM);
		
	for(%i = 0; %i < $TAILSEGMENTCOUNT; %i++)
	{
		if(%this.tail[%i].getImageMap() !$= $TAILIM)
		%this.tail[%i].setImageMap($TAILIM);		
	}
}