///////////////////////////////////////////////////////GLOBAL VARIABLES
$TENTACLESEGMENTCOUNT = 4;//10;
$TENTACLEAMOUNT = 4;
$TENTACLEOFFSET = 0.6;

$MEGAJELLIES[0] = 0;
$MEGAJELLIES[1] = 0;
$MEGAJELLYCOUNT = 0;

///////////////////////////////////////////////////////PRE-DEFINED

function JellyFishClass::onAdd(%this,%scenegraph)
{	
	if(%this.sizeFactor > 1)
	{
		%this.setSize(%this.getWidth()*%this.sizeFactor,%this.getHeight()*%this.sizeFactor);
		$MEGAJELLIES[$MEGAJELLYCOUNT] = %this;
		$MEGAJELLYCOUNT++;
	}
	
	%this.baseTotal = 0;
	for(%j = 0; %j < $TENTACLEAMOUNT; %j++)
	{
		for(%i = $TENTACLESEGMENTCOUNT * %j; %i < $TENTACLESEGMENTCOUNT * (%j+1); %i++)
		{
			%this.tentacle[%i] = %this.makeTentacleSegment();
			
			if(%i == $TENTACLESEGMENTCOUNT * %j)
			{
				%this.tentacle[%i].mount(%this,((2/($TENTACLEAMOUNT+1))*%j)-$TENTACLEOFFSET,0,0,false,false,false,false);
				%this.baseTentacles[%this.baseTotal] = %this.tentacle[%i];
				%this.baseTentacles[%this.baseTotal].setRotation(getRandom(-30,30));
				%this.baseTotal++;
				
				%this.tentacle[%i].setSize(%this.tentacle[%i].getWidth()*%this.sizeFactor,%this.tentacle[%i].getHeight()*%this.sizeFactor);
			}
			else
			{
				%this.tentacle[%i].mount(%this.tentacle[%i-1],0,1,0,false,false,false,false);
				%this.tentacle[%i].setSize(%this.tentacle[%i].getWidth()*%this.sizeFactor,%this.tentacle[%i].getHeight()*%this.sizeFactor);
			}
		}
	}
	
	%this.enableUpdateCallback();
	%this.swingBase = 0;
	
	%this.speedMax = 5;
	%this.speedMin = -%this.speedMax;
	%this.hor = 0;
	%this.ver = 0;	
	%this.moveRandomly();
}

function JellyFishClass::onUpdate(%this)
{
	if(distanceBetweenPoints(%this,MainCat,"Both") < 70)
	{
		for(%i = 0; %i < $TENTACLESEGMENTCOUNT*$TENTACLEAMOUNT; %i++)
			%this.swingTentacles(%i);
	}
}

function JellyFishClass::onTimer(%this)
{
	%this.moveRandomly(%this);
}

function JellyFishClass::onRemove(%this)
{
	for(%i = 0; %i < $TENTACLESEGMENTCOUNT*$TENTACLEAMOUNT; %i++)
	{
		if(isObject(%this.tentacle[%i]))
		{
			makeDeadBodyPart(%this.tentacle[%i]);
			%this.tentacle[%i].safeDelete();
		}
	}
	
	makeDeadBodyPart(%this);
}

//////////////////////////////////////////////////////////SUPPORT

/*
	This handles moving the jellyfish's tentacles.
	PARAMS: %tentacleIndex = Which tentacle by index to move.
*/
function JellyFishClass::swingTentacles(%this,%tentacleIndex)
{
	//This slows down the swinging so it doesn't get out of hand.
	if((%this.tentacle[0].getRotation() < %this.swingBase && %this.tentacle[0].tentacleArrest > %this.swingBase) || 
		(%this.tentacle[0].getRotation() > %this.swingBase && %this.tentacle[0].tentacleArrest < %this.swingBase))
	{
		for(%i = 0; %i < $TENTACLESEGMENTCOUNT; %i++)
			%this.tentacle[%i].setRotation(%this.swingBase);	
	}
	
	for(%i = 0; %i < %this.baseTotal; %i++)
		%this.tentacle[%i*$TENTACLESEGMENTCOUNT].tentacleArrest = %this.tentacle[%i].getRotation();
		
	%this.swingBase = 0;
		
	//Move the tail segments.
	if(%tentacleIndex % $TENTACLESEGMENTCOUNT == 0 || %tentacleIndex == 0)
		%this.tentacle[%tentacleIndex].setRotation(%this.tentacle[%tentacleIndex].getRotation()+%this.tentacle[%tentacleIndex].swingFactor);
	else if(%tentacleIndex % 2 && %tentacleIndex % $TENTACLESEGMENTCOUNT != 0)
		%this.tentacle[%tentacleIndex].setRotation( -(%this.tentacle[%tentacleIndex-1].getRotation()+%this.tentacle[%tentacleIndex-1].swingFactor*-4));
	else
		%this.tentacle[%tentacleIndex].setRotation(%this.tentacle[%tentacleIndex-1].getRotation()+%this.tentacle[%tentacleIndex-1].swingFactor*-4);
	
	//Add swinging momentum.
	if(%this.tentacle[%tentacleIndex].getRotation() > %this.swingBase)
		%this.tentacle[%tentacleIndex].swingFactor -= %this.tentacle[%tentacleIndex].rotateAdd;
		
	if(%this.tentacle[%tentacleIndex].getRotation() < %this.swingBase)
		%this.tentacle[%tentacleIndex].swingFactor += %this.tentacle[%tentacleIndex].rotateAdd;
}

function JellyFishClass::makeTentacleSegment(%this)
{
	%tentacle = new t2dStaticSprite()
	{
		Scenegraph = %this.getScenegraph();
		imageMap = "JellyfishTentacleSegmentIMImageMap";
		Config = "JellyFishTentacle";
		CollisionList = "0 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31";
	};

	%tentacle.swingFactor = 3;
	%tentacle.rotateAdd = 0.1;
	%this.tentacle[0].tentacleArrest = 1000;
	return %tentacle;
}

/*
This handles the randomness of the monsters movements
*/
function JellyFishClass::moveRandomly(%this)
{
	%this.hor = getRandom(%this.speedMin, %this.speedMax);
	if(%this.hor > 0) 
		%this.hor = %this.speedMax;
	else if(%this.hor < 0) 
		%this.hor = %this.speedMin;
		
	%this.ver = getRandom(%this.speedMin, %this.speedMax);
	if(%this.ver > 0) 
		%this.ver = %this.speedMax;
	else if(%this.ver < 0) 
		%this.ver = %this.speedMin;
	
	%this.setLinearVelocity(%this.hor,%this.ver);
	
	%this.setTimerOn(getRandom(800,1200));
}