///////////////////////////////////////////////////////PRE-DEFINED
function LevelSelectTileLayerClass::onLevelLoaded(%this,%scenegraph)
{
	%this.setUseMouseEvents(true);
	
	%this.makeStarsAndNumbers();
}

$ONCELOAD = false;

function LevelSelectTileLayerClass::onMouseDown(%this, %modifier, %worldPosition, %clicks)
{
	%xDis = distanceBetweenPoints((%this.getPositionX()-%this.getWidth()/2),%worldPosition,"HORIZONTAL");
	%yDis = distanceBetweenPoints((%this.getPositionY()-%this.getHeight()/2),%worldPosition,"VERTICAL");
	
	%col = mFloor(%xDis / %this.getTileSizeX());
	%row = mFloor(%yDis / %this.getTileSizeY());
	
	if($FURTHESTLEVELREACHED >= ((%row*10)+(%col+1)))
	{
		$currentLevel = (%row*10)+(%col+1);
		$startButtonLive = true;
		
		for(%i = 0; %i < $MEGAJELLYCOUNT; %i++)
			$MEGAJELLIES[%i] = 0;
		$MEGAJELLYCOUNT = 0;
		
		
		schedule(0,0,"loadScene",$levelNames[%col,%row]);
	}
}

//////////////////////////////////////////////////////////SUPPORT

function LevelSelectTileLayerClass::makeStarsAndNumbers(%this)
{
	$SAVEGAME.setPosition(0);
	%line = $SAVEGAME.readLine();
	while(getWord(%line,0) !$= "Stars")
	{
		%line = $SAVEGAME.readLine();
	}
	for(%level = 0; %level < $FURTHESTLEVELREACHED; %level++)
	{
		%x = %level % 10;
		%y = mFloor(%level / 10);
		
		%starX = %this.getCurrentTileX(%this,%x SPC %y);
		%starY = %this.getCurrentTileY(%this,%x SPC %y);
		
		if(getWord(%line,2) $= "1")
		{
			%this.makeBronzeStars(%starX,%starY);	
		}
		
		if(getWord(%line,3) $= "1")
		{
			%this.makeSilverStars(%starX,%starY);	
		}
		
		if(getWord(%line,4) $= "1")
		{
			%this.makeGoldStar(%starX,%starY);	
		}

		%number = new t2dTextObject()
   	{
 	  	  	Scenegraph = %this.Scenegraph;
			Config = "";
     	 	Text = %level+1;
			Font = "Tunga";
   	   TextAlign = "center";
      	HideOverflow = "true";
     		FontSizes = "81";
     		LineHeight = "10";
     		AspectRatio = "1";
     		LineSpacing = "0";
			CharacterSpacing = "0";
     		DstBlendFactor = "ONE_MINUS_DST_ALPHA";
      	BlendColor = "0.870588 0 0 1";
			layer = 1;
   	};
   	%number.setPosition(%starX,%starY);
   	
   	%line = $SAVEGAME.readLine();
	}
	
	$SAVEGAME.setPosition(0);
}

/*
	This draws two bronze stars in the correct places in the tile indicated.
	PARAMS: %starX = Current tile's x position, %starY = Current tile's y position.
*/
function LevelSelectTileLayerClass::makeBronzeStars(%this,%starX,%starY)
{
	for(%i = 0; %i < 2; %i++)
	{
		%star = new t2dStaticSprite()
		{
			ImageMap = "BronzeStarIMImageMap"; 
			Config = "BronzeStar";
			Scenegraph = %this.getScenegraph();
			Position = "0 0";
		};
		%star.setPosition(%starX+%star.xPosFactor[%i]SPC%starY+%star.yPosFactor[%i]);
	}	
}

/*
	This draws two silver stars in the correct places in the tile indicated.
	PARAMS: %starX = Current tile's x position, %starY = Current tile's y position.
*/
function LevelSelectTileLayerClass::makeSilverStars(%this,%starX,%starY)
{
	for(%i = 0; %i < 2; %i++)
	{
		%star = new t2dStaticSprite()
		{
			ImageMap = "SilverStarIMImageMap"; 
			Config = "SilverStar";
			Scenegraph = %this.getScenegraph();
			Position = "0 0";
		};
		%star.setPosition(%starX+%star.xPosFactor[%i]SPC%starY+%star.yPosFactor[%i]);
	}
}

/*
	This draws a gold star in the correct places in the tile indicated.
	PARAMS: %starX = Current tile's x position, %starY = Current tile's y position.
*/
function LevelSelectTileLayerClass::makeGoldStar(%this,%starX,%starY)
{
	%star = new t2dStaticSprite()
	{
		ImageMap = "GoldStarIMImageMap"; 
		Config = "GoldStar";
		Scenegraph = %this.getScenegraph();
		Position = "0 0";
	};
	%star.setPosition(%starX+%star.xPosFactor SPC %starY+%star.yPosFactor);
}

//////////////////////////////////////////////////////////LEVEL PROGRESS

$LEVELSTARS[0,0] = false; 
$LEVELSTARS[0,1] = false;  
$LEVELSTARS[0,2] = false; 

$LEVELSTARS[1,0] = false; 
$LEVELSTARS[1,1] = false; 
$LEVELSTARS[1,2] = false; 

$LEVELSTARS[2,0] = false; 
$LEVELSTARS[2,1] = false;  
$LEVELSTARS[2,2] = false; 

$LEVELSTARS[3,0] = false; 
$LEVELSTARS[3,1] = false;  
$LEVELSTARS[3,2] = false; 

$LEVELSTARS[4,0] = false; 
$LEVELSTARS[4,1] = false;  
$LEVELSTARS[4,2] = false; 