///////////////////////////////////////////////////////GLOBAL VARIABLES
$BADWOODIMAGE = "PlaceHolderWoodIMImageMap";
$HORDOORIMAGE = "DoorHorizontalIMImageMap";
$VERDOORIMAGE = "DoorVerticalIMImageMap";

//Wood blocks.
$WBH1  = "WoodBlockHor1IMImageMap";
$WBH2  = "WoodBlockHor2IMImageMap";
$WBV1  = "WoodBlockVer1IMImageMap";
$WBV2  = "WoodBlockVer2IMImageMap";

//Wood ends.
	//East.
$WEH1E = "WoodEndHor1EIMImageMap";
$WEH2E = "WoodEndHor2EIMImageMap";
	//West.
$WEH1W = "WoodEndHor1WIMImageMap";
$WEH2W = "WoodEndHor2WIMImageMap";
	//South.
$WEV1S = "WoodEndVer1SIMImageMap";
$WEV2S = "WoodEndVer2SIMImageMap";
	//North.
$WEV1N = "WoodEndVer1NIMImageMap";
$WEV2N = "WoodEndVer2NIMImageMap";

//Wood mids.
$WMH1  = "WoodMidHor1IMImageMap";
$WMH2  = "WoodMidHor2IMImageMap";
$WMV1  = "WoodMidVer1IMImageMap";
$WMV2  = "WoodMidVer2IMImageMap";

$GOODIEAMOUNT = 0;

///////////////////////////////////////////////////////PRE-DEFINED
function LevelTileLayerClass::onLevelLoaded(%this,%scenegraph)
{
	%line = 0;
	%goodieIndex = 2;
	%i = 0;
	$SAVEGAME.setPosition(0);
	while(!$SAVEGAME.isEOF())
	{
		//%lineStart = $LEVELSAVE[%i];
		%line = $SAVEGAME.readLine();
		$LEVELINDEX = %i;
		if(getSubStr(getWord(%line,0),0,1) $= "L")
		{
			if(getWord(%line,0) $= getLevelIndex())
			{
				$LEVELLINE = %line;
				break;	
			}
			for(%i = 2; !$SAVEGAME.isEOF();%i++)
			{
				%line = $SAVEGAME.readLine();
				if(getWord(%line,0) $= getLevelIndex())
					$LEVELLINE = %line;
			}
		}
		//$SAVEGAME.readLine();
	}
	$SAVEGAME.setPosition(0);
	//$LEVELINDEX
	$LINEPOS = getWord(%line,0);
	
	//%this.superClass = "BlockageClass";
	//For collisions.
	%this.setCollisionActive(false,true);
	%this.setCollisionCallback(true);
	%this.setCollisionPhysics(false,false);
	
	//DEBUG COUNT GOODIE TILES
	%goodies = 0;
	
	//This changes all the stupid wood to nice wood.
	for(%row = 0; %row < %this.getTileCountX(); %row++)
	{
		for(%col = 0; %col < %this.getTileCountY(); %col++)
		{
			%type = %this.getTileType(%row,%col);
			
			if(%this.getTileScript(%row,%col) $= "GoodieTile")
			{
				if(getWord(%line,%goodieIndex) == 1)
				{
					%this.setTileScript(%row SPC %col, "nothing");
					schedule(0,0,"specialTileToScreen",%this,%row SPC %col);
				}else
					%this.makeGoodie(%row,%col,%goodieIndex);
					
				%goodieIndex++;
				%goodies++;
			}
			
			//We found the cat and need to make it.
			if(%this.getTileScript(%row,%col) $= "CatTile")
			{
				%this.makeCat(%row,%col);
			}
			
			//We found a door we might have to fix.
			if(getWord(%this.getTileType(%row,%col),1) $= $HORDOORIMAGE || getWord(%this.getTileType(%row,%col),1) $= $VERDOORIMAGE)
			{
				%this.fixDoor(%row,%col);
			}
			
			//We found wood.
			if(getWord(%this.getTileType(%row,%col),1) $= $BADWOODIMAGE)
			{
				//The wood enhancing is so that you can make as many edits to the level and always have good looking wood
				//because the user decides where the walls are and the computer fixes them up nice. 
				%this.enhanceWood(%row,%col);	
			}
		}
	}
	
	//DEBUG NEED TO REMOVE
	//echo(%goodies);
}

function t2dTileMap::onTileScript(%map, %layer, %tile, %script)
{
	if(%script $= "FinishTile")
	{
		%xPos = %layer.getCurrentTileX(%layer,%tile);
		%yPos = %layer.getCurrentTileY(%layer,%tile);
		
		%newEffect = new t2dParticleEffect()
		{
			SceneGraph = %map.getSceneGraph();
			Layer = 16;
			Class = "FinishClass";//"AttackEffectClass";//"FinishClass";
			Size = "2 2";
			startX = %xPos;
			starty = %yPos;
		};
		
		%layer.setTileScript(%tile, "Finishing");
	
		schedule(0,0,"specialTileToScreen",%layer,%tile);
	}
	
	if(%script $= "HorDoor")
	{
		%xPos = %layer.getCurrentTileX(%layer,%tile);
		%yPos = %layer.getCurrentTileY(%layer,%tile);
		
		%newDoor = new t2dStaticSprite()
		{
			Scenegraph = %map.getSceneGraph();
			Config = "Door";
			ImageMap = "DoorHorizontalIMImageMap";
			Position = %xPos SPC %yPos;
			Layer = 24;
		};
		
		%layer.setTileScript(%tile, "nothing");
	
		schedule(0,0,"specialTileToScreen",%layer,%tile);
	}
	
	if(%script $= "VerDoor")
	{
		%xPos = %layer.getCurrentTileX(%layer,%tile);
		%yPos = %layer.getCurrentTileY(%layer,%tile);
		
		%newDoor = new t2dStaticSprite()
		{
			Scenegraph = %map.getSceneGraph();
			Config = "Door";
			ImageMap = "DoorVerticalIMImageMap";
			Position = %xPos SPC %yPos;
			Layer = 24;
		};
		
		%layer.setTileScript(%tile, "nothing");
	
		schedule(0,0,"specialTileToScreen",%layer,%tile);
	}
	
	if(%script $= "KeyTile")
	{
		%xPos = %layer.getCurrentTileX(%layer,%tile);
		%yPos = %layer.getCurrentTileY(%layer,%tile);
		
		%newKey = new t2dStaticSprite()
		{
			Scenegraph = %map.getSceneGraph();
			Config = "Key";
			ImageMap = "KeyIMImageMap";
			Position = %xPos SPC %yPos;
			CollisionPolyList = "-0.751 -0.452 0.854 -0.138 0.899 0.029 -0.756 0.344 -0.854 -0.069";
			CollisionList = "0 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31";
		};
		
		%layer.setTileScript(%tile, "nothing");
	
		schedule(0,0,"specialTileToScreen",%layer,%tile);
	}
	
	if(%script $= "SlashTile")
	{
		%xPos = %layer.getCurrentTileX(%layer,%tile);
		%yPos = %layer.getCurrentTileY(%layer,%tile);
		
		%newClaw = new t2dStaticSprite()
		{
			Scenegraph = %map.getSceneGraph();
			Config = "SlashPaw";
			ImageMap = "CatClawIMImageMap";
			Position = %xPos SPC %yPos;
			CollisionPolyList = "-0.378 -0.368 -0.162 -0.638 0.133 -0.648 0.417 -0.177 0.275 0.265 -0.314 0.265 -0.471 -0.118";
			CollisionList = "0 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31";
		};
		
		%layer.setTileScript(%tile, "nothing");
	
		schedule(0,0,"specialTileToScreen",%layer,%tile);
	}
	
	if(%script $= "CatTile")
	{
		/*%xPos = %layer.getCurrentTileX(%layer,%tile);
		%yPos = %layer.getCurrentTileY(%layer,%tile);
		
		%newCat = new t2dStaticSprite(MainCat)
		{
			Scenegraph = %map.getSceneGraph();
			Config = "CatPlayer";
			ImageMap = $BODYIM;
			Position = %xPos SPC %yPos;
		};
		
		//MainCat.setPosition(%xPos,%yPos);
		
		%layer.setTileScript(%tile, "nothing");
	
		schedule(0,0,"specialTileToScreen",%layer,%tile);*/
	}
	
	//if(%script $= "goodieTile")
	//{
		/*%xPos = %layer.getCurrentTileX(%layer,%tile);
		%yPos = %layer.getCurrentTileY(%layer,%tile);
		
		%newGoodie = new t2dStaticSprite()
		{
			Scenegraph = %map.getSceneGraph();
			Config = "Goodie";
			ImageMap = getRandomGoodie();
			Position = %xPos SPC %yPos;
			CollisionList = "0 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31";
		};
		
		%newGoodie.getPolyList();
		%layer.setTileScript(%tile, "nothing");
	
		schedule(0,0,"specialTileToScreen",%layer,%tile);*/
	//}
	
	if(%script $= "JellyFishTile")
	{
		%xPos = %layer.getCurrentTileX(%layer,%tile);
		%yPos = %layer.getCurrentTileY(%layer,%tile);
		
		%newJelly = new t2dStaticSprite()
		{
			Scenegraph = %map.getSceneGraph();
			Config = "JellyFishBaddie";
			ImageMap = "JellyfishHeadIMImageMap";
			Position = %xPos SPC %yPos;
			CollisionList = "0 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31";
			sizeFactor = 1;
			unkillable = false;
		};
		
		%layer.setTileScript(%tile, "nothing");
	
		schedule(0,0,"specialTileToScreen",%layer,%tile);
	}
	
	if(%script $= "MegaJellyFishTile")
	{
		%xPos = %layer.getCurrentTileX(%layer,%tile);
		%yPos = %layer.getCurrentTileY(%layer,%tile);
		
		%newJelly = new t2dStaticSprite()
		{
			Scenegraph = %map.getSceneGraph();
			Config = "JellyFishBaddie";
			ImageMap = "JellyfishHeadIMImageMap";
			Position = %xPos SPC %yPos;
			CollisionList = "0 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31";
			sizeFactor = 10;
			unkillable = true;
		};
		
		%layer.setTileScript(%tile, "nothing");
	
		schedule(0,0,"specialTileToScreen",%layer,%tile);
	}
	
	if(%script $= "BeastTile")
	{
		%xPos = %layer.getCurrentTileX(%layer,%tile);
		%yPos = %layer.getCurrentTileY(%layer,%tile);
		
		%newBeast = new t2dStaticSprite()
		{
			Scenegraph = %map.getSceneGraph();
			Config = "BeastBaddie";
			ImageMap = "BeastBodyIMImageMap";
			Position = %xPos SPC %yPos;
			unkillable = false;
		};
		
		%layer.setTileScript(%tile, "nothing");
	
		schedule(0,0,"specialTileToScreen",%layer,%tile);
	}
}

function LevelTileLayerClass::onCollision(%srcObject, %dstObject, %srcRef, %dstRef, %time, %normal, %contacts, %points)
{
	%xPos = %srcObject.getCurrentTileX(%srcObject,%srcRef);
	%yPos = %srcObject.getCurrentTileY(%srcObject,%srcRef);
	
	if(%dstObject.class $= "CatClass")
	{
		if(%srcObject.getTileScript(%srcRef) $= "Finishing")
		{
			%objectList = %srcObject.getScenegraph().getSceneObjectList();
			%goodieAmount = 0;
			for(%object = 0; getWord(%objectList,%object) !$= ""; %object++)
			{

				if(getWord(%objectList,%object).class $= "GoodieClass")
					%goodieAmount++;
			}
			
			$SAVEGAME.setPosition(0);
			%target = "Stars"@$currentLevel-1;
			while(!$SAVEGAME.isEOF())
			{
				%line = $SAVEGAME.readLine();
				if(getWord(%line,0) $= %target)
				{
					$LEVELSTARS[$currentLevel-1] = "Stars"@$currentLevel-1 SPC "1" SPC getWord(%line,2) SPC getWord(%line,3);
					break;
				}
			}
			
			if($currentLevel == $FURTHESTLEVELREACHED)
				$FURTHESTLEVELREACHED++;
			
			if($FURTHESTLEVELREACHED > 10)//DEBUG
				$FURTHESTLEVELREACHED = 10;
				
			$currentLevel = -1;
			SaveGame();	
			schedule(0,0,"loadScene","game/data/levels/LevelSelectScene 2.t2d");
		}
			
		%wallX = getWord(%normal,0);//1 = left | -1 = right
		%wallY = getWord(%normal,1);//1 = up   | -1 = down
		
		//Hit from the top
		if(%wallY == -1){
			//Get amount of offset based on how wide the sprites are.
			//%heightOffset = (%dstObject.getHeight()/2)+(%srcObject.getTileSizeY()/2);
			//%dstObject.setPositionY(%yPos-%heightOffset);
			%dstObject.setLinearVelocityY(0);
		}
		
		//Hit from the bottom
		if(%wallY == 1){
			//Get amount of offset based on how wide the sprites are.
			//%heightOffset = (%dstObject.getHeight()/2)+(%srcObject.getTileSizeY()/2);
			//%dstObject.setPositionY(%yPos+%heightOffset);
			%dstObject.setLinearVelocityY(0);		
		}		
		
		//Hit from the left
		if(%wallX == -1){
			//Get amount of offset based on how wide the sprites are.
			//%widthOffset = (%dstObject.getWidth()/2)+(%srcObject.getTileSizeX()/2);
			//%dstObject.setPositionX(%xPos-%widthOffset);
			%dstObject.setLinearVelocityX(0);			
		}
		
		//Hit from the right
		if(%wallX == 1){
			//Get amount of offset based on how wide the sprites are.
			//%widthOffset = (%dstObject.getWidth()/2)+(%srcObject.getTileSizeX()/2);
			//%dstObject.setPositionX(%xPos+%widthOffset);
			%dstObject.setLinearVelocityX(0);		
		}
	}
	
	if(%dstObject.class $= "BeastClass" || %dstObject.class $= "JellyFishClass")
	{
		%wallX = getWord(%normal,0);//1 = left | -1 = right
		%wallY = getWord(%normal,1);//1 = up   | -1 = down
		
		//Hit from the top
		if(%wallY == -1){
			//Get amount of offset based on how wide the sprites are.
			%heightOffset = (%dstObject.getHeight()/2)+(%srcObject.getTileSizeY()/2);
			%dstObject.setPositionY(%yPos-%heightOffset);
			%dstObject.setLinearVelocityY(-%dstObject.getLinearVelocityY());
		}
		
		//Hit from the bottom
		if(%wallY == 1){
			//Get amount of offset based on how wide the sprites are.
			%heightOffset = (%dstObject.getHeight()/2)+(%srcObject.getTileSizeY()/2);
			%dstObject.setPositionY(%yPos+%heightOffset);
			%dstObject.setLinearVelocityY(-%dstObject.getLinearVelocityY());		
		}		
		
		//Hit from the left
		if(%wallX == -1){
			//Get amount of offset based on how wide the sprites are.
			%widthOffset = (%dstObject.getWidth()/2)+(%srcObject.getTileSizeX()/2);
			%dstObject.setPositionX(%xPos-%widthOffset);
			%dstObject.setLinearVelocityX(-%dstObject.getLinearVelocityX());			
		}
		
		//Hit from the right
		if(%wallX == 1){
			//Get amount of offset based on how wide the sprites are.
			%widthOffset = (%dstObject.getWidth()/2)+(%srcObject.getTileSizeX()/2);
			%dstObject.setPositionX(%xPos+%widthOffset);
			%dstObject.setLinearVelocityX(-%dstObject.getLinearVelocityX());		
		}
	}
}

//////////////////////////////////////////////////////////SUPPORT

/*
	This makes a new goodie.
	PARAMS: %x = Current tile's x position in the tilelayer, %y = Current tile's y position in the tilelayer, 
*/
function LevelTileLayerClass::makeGoodie(%this,%x,%y,%goodieIndex)
{
	%xPos = %this.getCurrentTileX(%this,%x SPC %y);
	%yPos = %this.getCurrentTileY(%this,%x SPC %y);
	
	%newGoodie = new t2dStaticSprite()
	{
		Scenegraph = %this.getSceneGraph();
		Config = "Goodie";
		ImageMap = getRandomGoodie();
		Position = %xPos SPC %yPos;
		CollisionList = "0 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31";
		goodieNum = %goodieIndex;
	};
	
	%newGoodie.getPolyList();
	%this.setTileScript(%x SPC %y, "nothing");

	schedule(0,0,"specialTileToScreen",%this,%x SPC %y);
}

/*
	This makes the cat.
	PARAMS: %x = Current tile's x position in the tilelayer, %y = Current tile's y position in the tilelayer, 
*/
function LevelTileLayerClass::makeCat(%this,%x,%y)
{
	%tile = %x SPC %y;
	%xPos = %this.getCurrentTileX(%this,%tile);
	%yPos = %this.getCurrentTileY(%this,%tile);
	
	%newCat = new t2dStaticSprite(MainCat)
	{
		Scenegraph = %this.getSceneGraph();
		Config = "CatPlayer";
		ImageMap = $BODYIM;
		Position = %xPos SPC %yPos;
	};
	
	//MainCat.setPosition(%xPos,%yPos);
	
	%this.setTileScript(%tile, "nothing");

	schedule(0,0,"specialTileToScreen",%this,%tile);
}

/*
	Given the tile coordinates it edits any door tile to properly face the right way with wood or other doors around it.
	PARAMS: %x = Current tile's x position in the tilelayer, %y = Current tile's y position in the tilelayer, 
*/
function LevelTileLayerClass::fixDoor(%this,%x,%y)
{
	if(%x > 0)
	{
		if(getWord(%this.getTileType(%x-1,%y),1) $= $BADWOODIMAGE || %this.getTileScript(%x-1,%y) $= "Wood" || %this.getTileScript(%x-1,%y) $= "HorDoor" || %this.getTileScript(%x-1,%y) $= "VerDoor")
		{
			if(getWord(%this.getTileType(%x-1,%y),1) $= $BADWOODIMAGE || %this.getTileScript(%x-1,%y) $= "Wood")
				%westWood = true;
			%west = true;
		}
	}else
		%west = true;
	
	if(%x < %this.getTileCountX())
	{
		if(getWord(%this.getTileType(%x+1,%y),1) $= $BADWOODIMAGE || %this.getTileScript(%x+1,%y) $= "Wood" || %this.getTileScript(%x+1,%y) $= "HorDoor" || %this.getTileScript(%x+1,%y) $= "VerDoor")
		{
			if(getWord(%this.getTileType(%x+1,%y),1) $= $BADWOODIMAGE || %this.getTileScript(%x+1,%y) $= "Wood")
				%eastWood = true;
			%east = true;
		}
	}else
		%east = true;
		
	if(%y > 0)
	{
		if(getWord(%this.getTileType(%x,%y-1),1) $= $BADWOODIMAGE || %this.getTileScript(%x,%y-1) $= "Wood" || %this.getTileScript(%x,%y-1) $= "HorDoor" || %this.getTileScript(%x,%y-1) $= "VerDoor")
		{
			if(getWord(%this.getTileType(%x,%y-1),1) $= $BADWOODIMAGE || %this.getTileScript(%x,%y-1) $= "Wood")
				%northWood = true;
			%north = true;
		}
	}else
		%north = true;
		
	if(%y < %this.getTileCountY())
	{
		if(getWord(%this.getTileType(%x,%y+1),1) $= $BADWOODIMAGE || %this.getTileScript(%x,%y+1) $= "Wood" || %this.getTileScript(%x,%y+1) $= "HorDoor" || %this.getTileScript(%x,%y+1) $= "VerDoor")
		{
			if(getWord(%this.getTileType(%x,%y+1),1) $= $BADWOODIMAGE || %this.getTileScript(%x,%y+1) $= "Wood")
				%southWood = true;
			%south = true;
		}
	}else
		%south = true;
	
	//These do if statements enacts fixing doors position to prefer wood to other doors.
	if(%westWood && %eastWood)
	{
		%this.setTileScript(%x,%y, "HorDoor");
		return;
	}
		
	if(%northWood && %southWood)
	{
		%this.setTileScript(%x,%y, "VerDoor");
		return;
	}
	
	
	if(%west && %east)
	{
		if(%north && %south)
			%this.setTileScript(%x,%y, "VerDoor");
		%this.setTileScript(%x,%y, "HorDoor");
	}
	
	if(%north && %south)
	{
		if(%west && %east)
			%this.setTileScript(%x,%y, "HorDoor");
		%this.setTileScript(%x,%y, "VerDoor");	
	}
}

/*
	This is a strictly scheduled function that changes the image of a tile from debug to wire screen.
	PARAMS: %layer = Layer that contains the tile we want to change, %tile = Tile coordinates of the tile that we want to change
*/
function specialTileToScreen(%layer,%tile)
{
	%layer.setStaticTile(getWord(%tile,0),getWord(%tile,1),"WireScreenIMImageMap");
}

/*
	This returns the collision poly list for the new goodie depending on the imagemap.
*/ 
function GoodieClass::getPolyList(%this)
{
	switch$(%this.getImageMap())
	{
		case "YarnGoodieIMImageMap":	%this.setCollisionPolyCustom(6,"-0.805 0.386 -0.521 -0.867 0.987 -0.814 0.746 0.275 0.295 0.946 -0.476 0.909");
												return;
		case "RubberMouseGoodieIMImageMap":	%this.setCollisionPolyCustom(6,"0.246 -0.666 0.565 -0.692 0.609 -0.370 0.226 0.312 -0.383 0.682 -0.476 0.322");
														return;
		case "FeatherGoodieIMImageMap":	%this.setCollisionPolyCustom(4,"-0.997 -0.708 0.029 -0.539 0.624 0.396 0.432 1.000");
													return;
	}
}

/*
	This returns a random goodie imagemap.
*/
function getRandomGoodie()
{
	//For some reason, NOT putting the functions in the switch works better.
	%image = mFloor(getRandom(2));
	switch(%image)
	{
		case 0: return "YarnGoodieIMImageMap";
		case 1: return "FeatherGoodieIMImageMap";
		case 2: return "RubberMouseGoodieIMImageMap";
	}
}

/*
	This processes all the wood in a row changing it to better looking wood automaticly in the horizontal direction.
	PARAMS: %row = Current tile's x position in the tilelayer, %col = Current tile's y position in the tilelayer, 
*/	
function LevelTileLayerClass::enhanceHorizontalWood(%this,%row,%col)
{
	%woodPos = 0;//0 = start, 1 = mid, 2 = end
	%woodType = getRandom(1,2);//Must alternate.

	while(true)
	{
		if(%row == %this.getTileCountX() || !(getWord(%this.getTileType(%row+1,%col),1) $= $BADWOODIMAGE))
		{
			%this.makeWoodTile(%woodType,"END","HORIZONTAL",%row,%col);
			break;
		}
						
		if(%woodPos > 0)
		{
			%this.makeWoodTile(%woodType,"MID","HORIZONTAL",%row,%col);
			%woodPos++;
		}
						
		if(%woodPos == 0)
		{
			%this.makeWoodTile(%woodType,"START","HORIZONTAL",%row,%col);
			%woodPos++;
		}
						
		if(%woodType == 1)
			%woodType = 2;
		else 
			%woodType = 1;
				
		%row++;
	}
}

/*
	This processes all the wood in a row changing it to better looking wood automaticly in the vertical direction.
	PARAMS: %row = Current tile's x position in the tilelayer, %col = Current tile's y position in the tilelayer, 
*/	
function LevelTileLayerClass::enhanceVerticalWood(%this,%row,%col)
{
	%woodPos = 0;//0 = start, 1 = mid, 2 = end
	%woodType = getRandom(1,2);//Must alternate.

	while(true)
	{
		if(%col == %this.getTileCountY() || !(getWord(%this.getTileType(%row,%col+1),1) $= $BADWOODIMAGE))
		{
			%this.makeWoodTile(%woodType,"END","VERTICAL",%row,%col);
			break;
		}
						
		if(%woodPos > 0)
			%this.makeWoodTile(%woodType,"MID","VERTICAL",%row,%col);
						
		if(%woodPos == 0)
			%this.makeWoodTile(%woodType,"START","VERTICAL",%row,%col);
		
		%woodPos++;
						
		if(%woodType == 1)
			%woodType = 2;
		else 
			%woodType = 1;
				
		%col++;
	}
}

/*
	This decides and sets up the process of making a board or block of wood when a wood tile is found.
	PARAMS: %row = Current tile's x position in the tilelayer, %col = Current tile's y position in the tilelayer 
*/
function LevelTileLayerClass::enhanceWood(%this,%row,%col)
{
	%whichWay = -1;//-1 = NULL, 0 = go right, 1 = go down
	%right = %down = false;				
				
	//If there is wood to the right of the current wood.
	if(%row != %this.getTileCountX()){
	if(getWord(%this.getTileType(%row+1,%col),1) $= $BADWOODIMAGE){
		%right = true;				
	}}
				
	//If there is wood to the south of the current wood.
	if(%col != %this.getTileCountY()){
	if(getWord(%this.getTileType(%row,%col+1),1) $= $BADWOODIMAGE){
		%down = true;
	}}
	
	//This decides in which direction to make a board of wood depending on directions possible (to the right or down).
	if(%right && !%down)
		%whichWay = 0;
	if(!%right && %down)
		%whichWay = 1;
	if(%right && %down)
		%whichWay = getRandom(0,1);
					
	//For them single island woods.
	if(%whichWay == -1)
		%this.makeWoodTile(getRandom(1,4),"END","ISLAND",%row,%col);
					
	//For them horizontal woods
	if(%whichWay == 0)
		%this.enhanceHorizontalWood(%row,%col);
					
	//For them vertical woods
	if(%whichWay == 1)
		%this.enhanceVerticalWood(%row,%col);
}

/*
	Given the proper parameters it takes care of creating a proper wood tile
	PARAMS: %woodType = Either 1 or 2 it determines the look of the grain of the wood, %woodPos = Position within the piece of wood currently being built,
			  %angle = Indicates direction of the grain of the wood to eather horizontal or vertical, %row = Current tile's x position in the tilelayer, 
			  %col = Current tile's y position in the tilelayer
*/
function LevelTileLayerClass::makeWoodTile(%this,%woodType,%woodPos,%angle,%row,%col){
	if(%angle $= "ISLAND"){
		if(%woodType == 1)
			%this.setStaticTile(%row,%col,$WBH1);
		else if(%woodType == 2)
			%this.setStaticTile(%row,%col,$WBH2);
		else if(%woodType == 3)
			%this.setStaticTile(%row,%col,$WBV1);
		else if(%woodType == 4)
			%this.setStaticTile(%row,%col,$WBV2);
	}
	
	if(%angle $= "HORIZONTAL"){
		if(%woodPos $= "START"){ //Always starts in the west.
			if(%woodType == 1)
				%this.setStaticTile(%row,%col,$WEH1W);
			else if(%woodType == 2)
				%this.setStaticTile(%row,%col,$WEH2W);
		}
	
		if(%woodPos $= "MID"){
			if(%woodType == 1)
				%this.setStaticTile(%row,%col,$WMH1);
			else if(%woodType == 2)
				%this.setStaticTile(%row,%col,$WMH2);
		}	
		
		if(%woodPos $= "END"){ //Always ends in the east.
			if(%woodType == 1)
				%this.setStaticTile(%row,%col,$WEH1E);
			else if(%woodType == 2)
				%this.setStaticTile(%row,%col,$WEH2E);
		}	
	}else if(%angle $= "VERTICAL"){
		if(%woodPos $= "START"){ //Always start in the north.
			if(%woodType == 1)
				%this.setStaticTile(%row,%col,$WEV1N);
			else if(%woodType == 2)
				%this.setStaticTile(%row,%col,$WEV2N);
		}
	
		if(%woodPos $= "MID"){ 
			if(%woodType == 1)
				%this.setStaticTile(%row,%col,$WMV1);
			else if(%woodType == 2)
				%this.setStaticTile(%row,%col,$WMV2);
		}	
		
		if(%woodPos $= "END"){ //Always end in the south.
			if(%woodType == 1)
				%this.setStaticTile(%row,%col,$WEV1S);
			else if(%woodType == 2)
				%this.setStaticTile(%row,%col,$WEV2S);
		}	
	}
	
	//Allows for collisions.
	%this.setTileCollisionActive(%row,%col,true);
	%this.setTileCollisionPolyCustom(%row,%col, 4, "-1 -1, 1 -1, 1 1, -1 1");
	%this.setTileScript(%row,%col,"Wood");
}