//---------------------------------------------------------------------------------------------
// Torque Game Builder
// Copyright (C) GarageGames.com, Inc.
//---------------------------------------------------------------------------------------------
//
// This is the file you should define your custom datablocks that are to be used
// in the editor.
//

datablock t2dSceneObjectDatablock(JellyFishBaddie)
{
	Layer = 14;
	Size = "3.5 3.5";
	Class = "JellyFishClass";
	SuperClass = "BaddieClass";
	CollisionActiveReceive = true;
	CollisionActiveSend = true;
	CollisionCallback = true;
	CollisionPhysicsSend = false;
	CollisionPhysicsReceive = false;
	CollisionPolyList = "-0.810 -0.904 0.805 -0.889 0.874 0.064 0.216 0.766 -0.206 0.766 -0.859 0.079";
	CollisionDetectionMode = "FULL";
	
	CollisionCircleSuperscribed = false;
};
		datablock t2dSceneObjectDatablock(JellyFishTentacle)
		{
			Layer = 15;
			Size = "0.3 1";
			SuperClass = "BaddieClass";
			
			CollisionCircleSuperscribed = false;
		};
		
datablock t2dSceneObjectDatablock(BeastBaddie)
{
	Layer = 14;
	Size = "7 7";
	Class = "BeastClass";
	SuperClass = "BaddieClass";
	CollisionActiveReceive = true;
	CollisionActiveSend = true;
	CollisionCallback = true;
	CollisionPhysicsSend = false;
	CollisionPhysicsReceive = false;
	CollisionPolyList = "-0.103 -0.800 0.103 -0.800 0.162 -0.300 0.142 0.633 -0.177 0.633 -0.196 -0.300";
	CollisionDetectionMode = "FULL";
	
	CollisionCircleSuperscribed = false;
};
		datablock t2dSceneObjectDatablock(BeastBaddieClaw)
		{
			Layer = 15;
			Size = "1.5 1.5";
			SuperClass = "BaddieClass";
			
			CollisionCircleSuperscribed = false;
		};
		
		datablock t2dSceneObjectDatablock(BeastBaddieLegSegment)
		{
			Layer = 15;
			Size = "1 2";
			SuperClass = "BaddieClass";
			
			CollisionCircleSuperscribed = false;
		};
		
		datablock t2dSceneObjectDatablock(BeastBaddieTailSegment)
		{
			Layer = 15;
			Size = "1 2";
			SuperClass = "BaddieClass";
			
			CollisionCircleSuperscribed = false;
		};
		
		datablock t2dSceneObjectDatablock(BeastBaddieTailEnd)
		{
			Layer = 15;
			Size = "1 1";
			SuperClass = "BaddieClass";
			
			CollisionCircleSuperscribed = false;
		};


datablock t2dSceneObjectDatablock(CatPlayer)
{
	Layer = 13;
	Size = "7.5 7.5";
	Class = "CatClass";
	CollisionActiveReceive = true;
	CollisionActiveSend = true;
	CollisionCallback = true;
	CollisionPhysicsSend = false;
	CollisionPhysicsReceive = false;
	CollisionPolyList = "-0.750 -0.750 0.750 -0.750 0.750 1.000 -0.750 1.000";
	CollisionDetectionMode = "FULL";
	
	CollisionCircleSuperscribed = false;
};

//////////////////////CAT PARTS///////////////////
				datablock t2dSceneObjectDatablock(CatHead)
				{
					Layer = 12;
					Size = "2.3 2.3";
					
					CollisionCircleSuperscribed = false;
				};
				
				datablock t2dSceneObjectDatablock(CatTail)
				{
					Layer = 16;
					Size = "1.2 3";
					
					CollisionCircleSuperscribed = false;
				};

				datablock t2dSceneObjectDatablock(CatFrontLeg)
				{
					Layer = 14;
					Size = "1 1.5";
					
					CollisionCircleSuperscribed = false;
				};

				datablock t2dSceneObjectDatablock(CatFrontPaw)
				{
					Layer = 15;
					Size = "1.2 1.2";
					
					CollisionCircleSuperscribed = false;
				};

				datablock t2dSceneObjectDatablock(CatBackLeg)
				{
					Layer = 14;
					Size = "1 1.5";
					
					CollisionCircleSuperscribed = false;
				};

				datablock t2dSceneObjectDatablock(CatBackPaw)
				{
					Layer = 15;
					Size = "1.2 1.2";
					
					CollisionCircleSuperscribed = false;
				};
//////////////////////CAT PARTS///////////////////

datablock t2dSceneObjectDatablock(Dirigible)
{
	Layer = "1";
	Size = "15 8";
	Class = "DirigibleClass";
	
	CollisionCircleSuperscribed = false;
};

datablock t2dSceneObjectDatablock(Door)
{
	Layer = 15;
	Size = "10 10";
	Class = "DoorClass";
	//Superclass = "BlockageClass";
	CollisionActiveReceive = true;
	CollisionActiveSend = true;
	CollisionCallback = true;
	CollisionPhysicsSend = false;
	CollisionPhysicsReceive = false;
	CollisionDetectionMode = "FULL";
	
	CollisionCircleSuperscribed = false;
};

datablock t2dSceneObjectDatablock(OpenDoor)
{
	Layer = 20;
	Size = "10 10";
	Class = "OpenDoorClass";
	CollisionActiveReceive = true;
	CollisionActiveSend = true;
	CollisionCallback = true;
	CollisionPhysicsSend = false;
	CollisionPhysicsReceive = false;
	CollisionDetectionMode = "FULL";
	
	CollisionCircleSuperscribed = false;
};

datablock t2dSceneObjectDatablock(Goodie)
{
	Layer = 15;
	Size = "7.5 7.5";
	Class = "GoodieClass";
	CollisionActiveReceive = true;
	CollisionActiveSend = true;
	CollisionCallback = true;
	CollisionPhysicsSend = false;
	CollisionPhysicsReceive = false;
	CollisionDetectionMode = "FULL";
	CollisionLayers = "0 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31";
	
	CollisionCircleSuperscribed = false;
};

datablock t2dSceneObjectDatablock(Key)
{
	Layer = 15;
	Size = "7.5 7.5";
	Class = "KeyClass";
	CollisionActiveReceive = true;
	CollisionActiveSend = true;
	CollisionCallback = true;
	CollisionPhysicsSend = false;
	CollisionPhysicsReceive = false;
	CollisionDetectionMode = "FULL";
	
	CollisionCircleSuperscribed = false;
};

datablock t2dSceneObjectDatablock(Score)
{
	Layer = 14;
	Class = "ScoreClass";
	
	CollisionCircleSuperscribed = false;
};

datablock t2dSceneObjectDatablock(ScoreKeeper)
{
	Layer = 0;
	Size = "1 1";
	Class = "ScoreKeeperClass";	
	
	CollisionCircleSuperscribed = false;
};

datablock t2dSceneObjectDatablock(SlashPaw)
{
	Layer = 15;
	Size = "9 9";
	Class = "ClawClass";
	CollisionActiveReceive = true;
	CollisionActiveSend = true;
	CollisionCallback = true;
	CollisionPhysicsSend = false;
	CollisionPhysicsReceive = false;
	CollisionDetectionMode = "FULL";
	
	CollisionCircleSuperscribed = false;
};

datablock t2dSceneObjectDatablock(SpiderBaddie)
{
	Layer = 15;
	Size = "7 7";
	Class = "SpiderClass";
	CollisionActiveReceive = true;
	CollisionActiveSend = true;
	CollisionCallback = true;
	CollisionPhysicsSend = false;
	CollisionPhysicsReceive = false;
	CollisionPolyList = "1.000 -1.000 1.000 1.000 -1.000 1.000 -1.000 -1.000";
	CollisionDetectionMode = "FULL";
	
	CollisionCircleSuperscribed = false;
};
		datablock t2dSceneObjectDatablock(SpiderLegSegment)
		{
			Layer = 14;
			Size = "0.3 1";
			
			CollisionCircleSuperscribed = false;
		};

//////////////////////STARS///////////////////
datablock t2dSceneObjectDatablock(GoldStar)
{
	Layer = 5;
	Size = "3.2 3.2";
	xPosFactor = 0;
	yPosFactor = -2;
};

datablock t2dSceneObjectDatablock(SilverStar)
{
	Layer = 5;
	Size = "2.4 2.4";
	xPosFactor[0] = -1.7;
	yPosFactor[0] = 0;
	xPosFactor[1] = 1.7;
	yPosFactor[1] = 0;
};

datablock t2dSceneObjectDatablock(BronzeStar)
{
	Layer = 5;
	Size = "2 2";
	xPosFactor[0] = -2;
	yPosFactor[0] = 2;
	xPosFactor[1] = 2;
	yPosFactor[1] = 2;
};

//////////////////////STARS///////////////////

datablock t2dSceneObjectDatablock(TargetCircle)
{
	Layer = 14;
	Size = "5 5";
	Class = "TargetCircleClass";
	Position = "0 0";
	Visible = true;
};