//---------------------------------------------------------------------------------------------
// Torque Game Builder
// Copyright (C) GarageGames.com, Inc.
//---------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------
// startGame
// All game logic should be set up here. This will be called by the level builder when you
// select "Run Game" or by the startup process of your game to load the first level.
//---------------------------------------------------------------------------------------------
function startGame(%level)
{
	exec("./LevelHandling.cs");
	exec("./SaveGameScripts.cs");
	exec("./Handy Custom Torque Functions.cs");
	exec("./TBAScripts.cs");	
	
	exec("./EffectClassesScripts.cs");
	exec("./BodyPartsClassScripts.cs");
	exec("./ArrowButtonsScripts.cs");
	exec("./BackgroundClassScripts.cs");
	exec("./CatClassScripts.cs");
	exec("./CatClassPartsScripts.cs");
	exec("./CatEditorButtonClassScripts.cs");	
	exec("./CloudClassScripts.cs");	
	exec("./CloudMakerClassScripts.cs");
	exec("./CollectablePartClass.cs");
	exec("./DirigibleClassScripts.cs");
	exec("./DoorClassScripts.cs");
	exec("./PartChangingClassesScripts.cs");
	exec("./OrbitingKeyClassScripts.cs");
	exec("./PressEnterClassScripts.cs");
	exec("./LevelSelectTileLayerClassScripts.cs");
	exec("./LevelTileLayerClassScripts.cs");
	exec("./ScoreClassScripts.cs");
	exec("./ScoreKeeperClassScripts.cs");
	exec("./SlashPawClassScripts.cs");
	exec("./StartGameButtonClassScripts.cs");
	exec("./StarClassScripts.cs");
	exec("./t2dSceneWindowClassScripts.cs");
	exec("./JellyFishClassScripts.cs");
	exec("./BeastClassScripts.cs");
	exec("./SpiderClassScripts.cs");
	
	exec("./DEBUGGING AND BETA TESTING.cs");
	
	$SAVEGAME = new FileStreamObject();
	$SAVEGAME.open("~/save.txt",ReadWrite);
	
	//newGameFile();
	loadVariables();
	SaveGame();
	
	$TBA = 1;
	
	loadVariables();
	
   Canvas.setContent(mainScreenGui);
   Canvas.setCursor(DefaultCursor);
   
   new ActionMap(moveMap);   
   moveMap.push();
   
   screeny();moveMap.bindCmd("keyboard","0","doScreenShot();","");
   
   $enableDirectInput = true;
   activateDirectInput();
   enableJoystick();
   
   sceneWindow2D.loadLevel(%level);
   sceneWindow2D.setUseObjectMouseEvents(true);
}

//---------------------------------------------------------------------------------------------
// endGame
// Game cleanup should be done here.
//---------------------------------------------------------------------------------------------
function endGame()
{
   sceneWindow2D.endLevel();
   moveMap.pop();
   moveMap.delete();
}