///////////////////////////////////////////////////////PRE-DEFINED

function sceneWindow2D::onMouseUp(%this, %modifier, %worldPos, %mouseClicks )
{
	if($startButtonLive && isObject(MainCat))
	{
		startTheLevel();
	}else
		MainCat.mouseMove = false;
	if(isObject(StartGameButton))
	{
		if(StartGameButton.clicked == true)
		{
			StartGameButton.clicked = false;
			StartGameButton.setSize(StartGameButton.getWidth()+StartGameButton.shrinkFactor,StartGameButton.getHeight()+StartGameButton.shrinkFactor);
		}
	}
}

function sceneWindow2D::onMouseDragged(%this, %modifier, %worldPos, %mouseClicks )
{
	if(!$startButtonLive)
	{
		MainCat.mouseMove = true;
	}
}

function sceneWindow2D::onMouseDown(%this, %modifier, %worldPos, %mouseClicks )
{
	if(!$startButtonLive)
	{
		if(MainCat.mouseTarget $= "EMPTY")
		{
			MainCat.mouseTarget = new t2dStaticSprite()
			{
				Scenegraph = MainCat.getScenegraph();
				imageMap = "WhiteCircleIMImageMap";
				Position = %worldPos;
				Config = "TargetCircle";
			};
		}
		MainCat.mouseMove = true;	
	}
}

//////////////////////////////////////////////////////////SUPPORT

function startTheLevel()
{
	if($startButtonLive)
	{
		sceneWindow2D.startButton.safeDelete();
		sceneWindow2D.pressEnter.safeDelete();
		$startButtonLive = false;
	}
	
	if(!isObject(MainCat))
	{
		schedule(0,0,"restartLevel");	
	}
}

/*
	This makes the start button and the press enter button.
*/
function sceneWindow2D::makeStartDisplay(%this)
{	
	%this.startButton = new t2dAnimatedSprite()
	{
		Scenegraph = %this.getScenegraph();
		Position = %this.getPosition();
		animationName = "LevelStartButtonIMAnimation";
		Size = "50 20";
	};
   
   %this.pressEnter = new t2dTextObject()
   {
      Scenegraph = %this.getScenegraph();
      Text = "PRESS ENTER OR CLICK MOUSE";
      Font = "DS-Digital";
      TextAlign = "right";
      HideOverflow = "0";
      LineHeight = "8";
      FontSizes = "102";
      class = "PressEnterClass"; 
   };
   
   %size = sceneWindow2D.getWorldPoint(getWord(sceneWindow2D.getWindowExtents(),2)/2,getWord(sceneWindow2D.getWindowExtents(),3)/2);
	sceneWindow2D.startButton.setPosition(getWord(%size,0),getWord(%size,1));
	sceneWindow2D.pressEnter.setPosition(getWord(%size,0)+44,getWord(%size,1)-20);
}

/*
	This resets the current level.
*/
function restartLevel()
{
	sceneWindow2D.endLevel();
	moveMap.pop();
	sceneWindow2D.loadLevel($LEVEL[$currentLevel]);
	moveMap.push();
}

/*
	This makes the game go to the next level.
*/
function sceneWindow2D::nextLevelPlease(%this)
{
	MainCat.safeDelete(); //Make sure no funny business happens.
	%this.endLevel();
	moveMap.pop();
	$currentLevel++;
	%this.loadLevel($levelNames[$currentLevel]);
	moveMap.push();
}

/*
	This makes the game go to the level select screen.
*/
function sceneWindow2D::backToSelectScreen(%this)
{
	MainCat.safeDelete(); //Make sure no funny business happens.
	%this.endLevel();
	moveMap.pop();
	%this.loadLevel("game/data/levels/LevelSelectScene.t2d");
	moveMap.push();
	$startButtonLive = false;
}